#include <stdio.h>
#include <stdlib.h>

typedef struct linked_node linked_node;
struct linked_node {
	char data;
	linked_node *next;
};

// retornar o ponteiro do primeiro
linked_node *adicionar_no_final(linked_node *inicio, char nova_base) {

	linked_node *novo = malloc(sizeof(linked_node));
	novo->data = nova_base;
	novo->next = NULL;

	if (inicio == NULL)
		return novo;

	linked_node *anterior = NULL;   
	linked_node *atual = inicio;
	while (atual != NULL) {
		anterior = atual;
		atual = atual->next;
	}
	anterior->next = novo;
	return inicio;
}

void imprimir_lista(linked_node *atual) {
    if (atual == NULL) {
		printf("\n");
		return;
    }
    printf("%c", atual->data);
    imprimir_lista(atual->next);
}

void liberar_lista(linked_node *atual) {
	if (atual == NULL) return;
	liberar_lista(atual->next);
	free(atual);
}

int main() {
  
  linked_node *inicio = NULL; // precisamos guardar o ponteiro para o primeiro elemento!

  char atual;
  atual = getchar();
  while (atual != '0') {
	inicio = adicionar_no_final(inicio, atual);
	atual = getchar();
  } 

  imprimir_lista(inicio);
  
  liberar_lista(inicio);
  
  return 0;
}

