#include <stdio.h>
#include <stdlib.h>

typedef struct linked_node linked_node;
struct linked_node {
	int data;
	linked_node *next;
};

void imprimir_iter(linked_node *inicio) {
	linked_node *atual = inicio;	
	while (atual != NULL) {
		printf("%d ", atual->data);
		atual = atual->next;
	}
	printf("\n");
}

void imprimir_rec(linked_node *atual) {
	if (atual == NULL) return;
	printf("%d ", atual->data);
	imprimir_rec(atual->next);
}

void imprimir_rec_contrario(linked_node *atual) {
	if (atual == NULL) return;
	imprimir_rec_contrario(atual->next);
	printf("%d ", atual->data);
}

// retornar o ponteiro do primeiro
linked_node *adicionar_no_final(linked_node *inicio, int novo_valor) {

	linked_node *novo = malloc(sizeof(linked_node));
	novo->data = novo_valor;
	novo->next = NULL;
	
	if (inicio == NULL) {
		return novo;
	}

	linked_node *anterior = NULL;
	linked_node *atual = inicio;
	while (atual != NULL) {
		anterior = atual;
		atual = atual->next;
	}
	anterior->next = novo;

	return inicio;
}

int main() {

	linked_node *inicio = NULL;

	inicio = adicionar_no_final(inicio, 20);
	inicio = adicionar_no_final(inicio, 60);
	inicio = adicionar_no_final(inicio, 90);

	imprimir_rec(inicio);

	return 0;
}
